Index: src/apps/codycam/CodyCam.cpp
===================================================================
--- src/apps/codycam/CodyCam.cpp	(revision 24847)
+++ src/apps/codycam/CodyCam.cpp	(working copy)
@@ -746,7 +746,7 @@
 	aFrame.bottom -= kYBuffer;
 
 	fFtpSetupBox = new BBox(aFrame, "Ftp Setup", B_FOLLOW_ALL, B_WILL_DRAW);
-	fUploadClientMenu = new BPopUpMenu("Send to...");
+	fUploadClientMenu = new BPopUpMenu("Send to" B_UTF8_ELLIPSIS);
 	for (int i = 0; kUploadClient[i]; i++) {
 		BMessage *m = new BMessage(msg_upl_client);
 		m->AddInt32("client", i);
@@ -821,7 +821,7 @@
 	aFrame = fStatusBox->Bounds();
 	aFrame.InsetBy(kXBuffer, kYBuffer);	
 
-	fStatusLine = new BStringView(aFrame, "Status Line", "Waiting ...");
+	fStatusLine = new BStringView(aFrame, "Status Line", "Waiting" B_UTF8_ELLIPSIS);
 	fStatusBox->AddChild(fStatusLine);
 }
 
Index: src/apps/codycam/VideoConsumer.cpp
===================================================================
--- src/apps/codycam/VideoConsumer.cpp	(revision 24847)
+++ src/apps/codycam/VideoConsumer.cpp	(working copy)
@@ -647,7 +647,7 @@
 {
 	BFile* output;
 
-	UpdateFtpStatus("Capturing Image ...");
+	UpdateFtpStatus("Capturing Image" B_UTF8_ELLIPSIS);
 
 	/* save a local copy of the image in the requested format */
 	output = new BFile();
@@ -695,14 +695,14 @@
 	ftp->SetPassive(fPassiveFtp);
 		// ftp the local file to our web site
 
-	UpdateFtpStatus("Logging in ...");
+	UpdateFtpStatus("Logging in" B_UTF8_ELLIPSIS);
 	if (ftp->Connect((string)fServerText, (string)fLoginText, (string)fPasswordText)) {
 		// connect to server
-		UpdateFtpStatus("Connected ...");
+		UpdateFtpStatus("Connected" B_UTF8_ELLIPSIS);
 
 		if (ftp->ChangeDir((string)fDirectoryText)) {
 			// cd to the desired directory
-			UpdateFtpStatus("Transmitting ...");
+			UpdateFtpStatus("Transmitting" B_UTF8_ELLIPSIS);
 
 			if (ftp->PutFile((string)filename, (string)"temp")) {
 				// send the file to the server
@@ -710,7 +710,7 @@
 				ftp->Chmod((string)"temp", (string)"644");
 				// make it world readable
 
-				UpdateFtpStatus("Renaming ...");
+				UpdateFtpStatus("Renaming" B_UTF8_ELLIPSIS);
 
 				if (ftp->MoveFile((string)"temp", (string)filename)) {
 					// change to the desired name
Index: src/apps/processcontroller/KernelMemoryBarMenuItem.cpp
===================================================================
--- src/apps/processcontroller/KernelMemoryBarMenuItem.cpp	(revision 24847)
+++ src/apps/processcontroller/KernelMemoryBarMenuItem.cpp	(working copy)
@@ -28,7 +28,7 @@
 
 
 KernelMemoryBarMenuItem::KernelMemoryBarMenuItem(system_info& systemInfo)
-	: BMenuItem("System Resources & Caches...", NULL)
+	: BMenuItem("System Resources & Caches" B_UTF8_ELLIPSIS, NULL)
 {
 	fLastSum = -1;
 	fGrenze1 = -1;
Index: src/apps/processcontroller/NoiseBarMenuItem.cpp
===================================================================
--- src/apps/processcontroller/NoiseBarMenuItem.cpp	(revision 24847)
+++ src/apps/processcontroller/NoiseBarMenuItem.cpp	(working copy)
@@ -25,7 +25,7 @@
 
 
 NoiseBarMenuItem::NoiseBarMenuItem()
-	: BMenuItem("Gone Teams...", NULL)
+	: BMenuItem("Gone Teams" B_UTF8_ELLIPSIS, NULL)
 {
 	fBusyWaiting = -1;
 	fLost = -1;
Index: src/apps/processcontroller/ProcessController.cpp
===================================================================
--- src/apps/processcontroller/ProcessController.cpp	(revision 24847)
+++ src/apps/processcontroller/ProcessController.cpp	(working copy)
@@ -260,7 +260,7 @@
 					if (alert->Go())
 						kill_team(team);
 				} else {
-					alert = new BAlert("", "This team is already gone...", "Ok!", NULL, NULL, B_WIDTH_AS_USUAL, B_STOP_ALERT);
+					alert = new BAlert("", "This team is already gone" B_UTF8_ELLIPSIS, "Ok!", NULL, NULL, B_WIDTH_AS_USUAL, B_STOP_ALERT);
 					alert->Go();
 				}
 			}
@@ -296,7 +296,7 @@
 					}
 					#endif
 				} else {
-					alert = new BAlert("", "This thread is already gone...", "Ok!", NULL, NULL, B_WIDTH_AS_USUAL, B_STOP_ALERT);
+					alert = new BAlert("", "This thread is already gone" B_UTF8_ELLIPSIS, "Ok!", NULL, NULL, B_WIDTH_AS_USUAL, B_STOP_ALERT);
 					alert->Go();
 				}
 			}
Index: src/apps/packageinstaller/PackageView.cpp
===================================================================
--- src/apps/packageinstaller/PackageView.cpp	(revision 24847)
+++ src/apps/packageinstaller/PackageView.cpp	(working copy)
@@ -586,7 +586,7 @@
 			}
 			fDestination->AddSeparatorItem();
 
-			item = new BMenuItem("Other...", new BMessage(P_MSG_OPEN_PANEL));
+			item = new BMenuItem("Other" B_UTF8_ELLIPSIS, new BMessage(P_MSG_OPEN_PANEL));
 			item->SetTarget(this);
 			fDestination->AddItem(item);
 
Index: src/apps/terminal/TermWindow.cpp
===================================================================
--- src/apps/terminal/TermWindow.cpp	(revision 24847)
+++ src/apps/terminal/TermWindow.cpp	(working copy)
@@ -142,7 +142,7 @@
 	fFilemenu->AddItem(new BMenuItem("New Tab", new BMessage(kNewTab), 'T'));
 	
 	fFilemenu->AddSeparatorItem();
-	fFilemenu->AddItem(new BMenuItem("Page Setup...", new BMessage(MENU_PAGE_SETUP)));
+	fFilemenu->AddItem(new BMenuItem("Page Setup" B_UTF8_ELLIPSIS, new BMessage(MENU_PAGE_SETUP)));
 	fFilemenu->AddItem(new BMenuItem("Print", new BMessage(MENU_PRINT),'P'));
 	fFilemenu->AddSeparatorItem();
 	fFilemenu->AddItem(new BMenuItem("About Terminal" B_UTF8_ELLIPSIS, new BMessage(B_ABOUT_REQUESTED)));
Index: src/apps/mail/MailWindow.cpp
===================================================================
--- src/apps/mail/MailWindow.cpp	(revision 24847)
+++ src/apps/mail/MailWindow.cpp	(working copy)
@@ -2956,7 +2956,7 @@
 		delete item;
 	}
 
-	fQueryMenu->AddItem(new BMenuItem(MDR_DIALECT_CHOICE("Edit Queries...","???..."),
+	fQueryMenu->AddItem(new BMenuItem(MDR_DIALECT_CHOICE("Edit Queries" B_UTF8_ELLIPSIS,"???" B_UTF8_ELLIPSIS),
 		new BMessage(M_EDIT_QUERIES), 'E', B_SHIFT_KEY));
 
 	bool queryItemsAdded = false;